c***************************************************************
c      gnuTRACK
c      Pere Casellas 2012
c      pere@laboratoridenvol.com 
c      Aquest programa es pot usar, estudiar, copiar, modificar, i 
c      redistribuir lliurement conforme la
c      GNU General Public License 2.0 (http://www.gnu.org)
c     
c      Compila sota gcc(f77) en GNU/Linux
c***************************************************************
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      VARIABLES DECLARATION
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       real x1,y1,x2,y2
       real p1x,p1y,p2x,p2y

       real winds, windc

       real x(0:1000), y(0:1000), z(0:1000), at(0:1000)

       real ds(0:1000), s(0:1000), r(0:1000), vh(0:1000), vz(0:1000)

        real sc(0:1000), vhx(0:1000), vhy(0:1000), vre(0:1000)

       real vwx(0:1000),  vwy(0:1000), vrx(0:1000), vry(0:1000)

       real grr(0:1000), sac(0:1000)
 
       character*50 azone, adate, apilot, aglider, fcode

       real ptv

       pi=4.*atan(1.)

c      write (*,*) "pi= ", pi
      
c       character*100 at(0:1000)

       write (*,*) 
       write (*,*) "*********************************************"
       write (*,*) "*   TRACK ANALYSIS by Laboratori d'envol    *"
       write (*,*) "*********************************************"
       write (*,*) "Draw and compute parameters from an GPS track"     
       write (*,*) 
      
       write (*,*) "Version 0.2 17-11-2012"
       write (*,*)
       write (*,*) "Pere Casellas"
       write (*,*) "pere@laboratoridenvol.com"
       write (*,*)
       write (*,*) "GNU General Public License 2.0 http://www.gnu.org"
       write (*,*) "*************************************************"
       write (*,*)
       write (*,*) "Computing..."
       write (*,*)
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      MOTOR DE CALCUL
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       open(unit=20, file='Longitudinal.dxf')
       open(unit=21, file='npunts.txt')
       open(unit=22, file='xyzt.txt')
       open(unit=24, file='flight.txt')
       open(unit=23, file='out.txt') 
       open(unit=25,file='Track-3d.dxf')
       
       call dxfinit(20)
       call dxfinit(25)
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      Lectura de del fitxer de dades
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       rewind (22)
       rewind (21)
       rewind (23)
       rewind (24)

       write (23,*)
       write (23,*) "TRACK ANALYSIS by Laboratori d'envol"
       write (23,*)

       read (21,*) npunts 

       read (24,*) azone
       read (24,*) adate
       read (24,*) fcode
       read (24,*) aglider
       read (24,*) apilot
       read (24,*) ptv
       read (24,*) winds
       read (24,*) windc

       write (23,*)
       write (23,*) "Points data X Y X t "
       write (23,*)

       do i=1, npunts
               
       read (22,*) x(i), y(i), z(i), at(i)

       write (23,'(I4,2x,F12.2,2x,F12.2,2x,F7.2,2x,F10.2)') 
     + i, x(i), y(i), z(i), at(i)

c       write (*,'(I4,2x,F12.2,2x,F12.2,2x,F7.2,2x,F10.2)') 
c     + i, x(i), y(i), z(i), at(i)


       end do


c      Calculs

       x(0)=x(1)
       y(0)=y(1)
       s(0)=0

       s(1)=0
       ds(1)=0

       r(1)=z(1)
       
       write (23,*)
       write (23,*) "Longitudinal profile "
       write (23,*)


       do i=1,npunts-1

       ds(i+1)=sqrt((x(i+1)-x(i))**2.+(y(i+1)-y(i))**2.)

       s(i+1)=ds(i+1)+s(i)

       r(i+1)=z(i+1)

       vh(i+1)=ds(i+1)/(at(i+1)-at(i))

       vz(i+1)=(z(i)-(z(i+1)))/(at(i+1)-at(i))

       sc(i+1)=atan((x(i+1)-x(i))/((y(i+1)-y(i))))
       if ((y(i+1)-y(i)).lt.0.) then
       sc(i+1)=pi+atan((x(i+1)-x(i))/((y(i+1)-y(i))))
       end if

       vhx(i+1)=vh(i+1)*sin(sc(i+1))

       vhy(i+1)=vh(i+1)*cos(sc(i+1))

       end do
       
c      Escriu punts i velocitats

       vh(1)=vh(2)
       vz(1)=vz(2)
       sc(1)=sc(2)
       vhx(1)=vhx(2)
       vhy(1)=vhy(2)

       do i=1,npunts

       write (23,'(I4,5(A,F8.2))') 
     + i, "  ds= ", ds(i), "  s= ", s(i), "  r= ", r(i), 
     + "  vh= ", vh(i)*3.6, "  vz= ", vz(i)

       end do

c      Vent

       do i=1,npunts

       vwx(i)=(winds/3.6)*sin(windc*pi/180.)
       vwy(i)=(winds/3.6)*cos(windc*pi/180.)

       end do

c      Velocitats corregides i finesa real

       write (23,*)
       write (23,*) "Segment  Course(deg)  Vh_wind  Vh_(real)  GR"
       write (23,*)

       do i=1, npunts

       vrx(i)=vhx(i)-vwx(i)
       vry(i)=vhy(i)-vwy(i)
       vre(i)=sqrt(vrx(i)**2.+vry(i)**2.)
       grr(i)=vre(i)/vz(i)

       write (23,'(I4,4(A,F8.2))') 
     + i, "  sc= ", sc(i)*180./pi, "  vh= ", vh(i)*3.6, 
     + "  vre= ", vre(i)*3.6, "   GR= ", grr(i)

c       write (23,*) "vel ", winds, windc, vhx, vhy, vrx, vry

       end do

c      Results

       write (23,*)
       write (23,*) "RESULTS "
       write (23,*)
       
       xhd=z(1)-z(npunts)
       xdl=s(npunts)
       xgrw=s(npunts)/(z(1)-z(npunts))
       xtd=at(npunts)-at(1)

       fligc=atan((x(npunts)-x(1))/(y(npunts)-y(1)))
       if (y(npunts)-y(1).lt.0.) then
       fligc=pi+atan((x(npunts)-x(1))/(y(npunts)-y(1)))
       end if

       write (23,'(2A)') "Flight Zone= ", azone
       write (23,'(2A)') "Date= ", adate
       write (23,'(2A)') "Flight code= ", fcode
       write (23,'(2A)') "Glider= ", aglider
       write (23,'(2A)') "Pilot= ", apilot
       write (23,'(A,F4.1,A)') "PTV= ", ptv, " Kg"
            write (23,'(A,I6)') "N points = ", npunts
       Write (23,'(A,F7.2,A)') "Height difference= ", xhd, " m"
       write (23,'(A,F7.2),A') "Developed length= ",  xdl, " m"
       write (23,'(A,F7.2)') "Glide ratio (with wind)= ", xgrw
       write (23,'(A,F10,A)') "Track duration= ", xtd , " s"      
       write (23,'(A,F5.2,A)') "H speed (with wind)= ", xdl/xtd, " m/s "
       write (23,'(A,F5.2,A)') "H speed (with wind)= ", 3.6*xdl/xtd,
     + " Km/h "
       write (23,'(A,F5.2,A)') "Sink rate (with wind)= ", xhd/xtd, 
     + " m/s "
       write (23,'(A,F7.2,A)') "Wind speed (aprox.)= ", winds, " km/h"
       write (23,'(A,F7.2,A)') "Wind course (N) (aprox.)= ", windc, 
     + " (0-360 deg)"
       write (23,'(A,F7.2,A)') "Flight course TK-LZ= ", fligc*180./pi

c      Average GR

       sac(1)=0.

       do i=2,npunts
       sac(i)=sac(i-1)+vre(i)*(at(i)-at(i-1))
       end do

       write (23,*) 
       write (23,'(A,F8.2,A)') "H distance with no wind= ", 
     + sac(npunts), " m"
       write (23,'(A,F8.2,A)') "H speed with no wind= ", 
     + 3.6*sac(npunts)/xtd, " km/h"
       write (23,'(A,F8.2)') "Average Glide Ratio of flight= ", 
     + sac(npunts)/xhd
       write (23,*)

c      Dibuixa track 3D i eixos

       do i=1,npunts-1

c      Dibuixa perfil longitudinal 2D

       call line (s(i),-r(i), s(i+1),-r(i+1),1)
       call line (sac(i),-r(i), sac(i+1),-r(i+1),3)
       call line (0.,0.,1000.,0.,2)
       call line (0.,0.,0.,1000.,2)

c      Dibuixa track 3D i eixos

       call line3d(x(i),y(i),z(i),x(i+1),y(i+1),z(i+1),6)

       call line3d(x(1),y(1),0.,x(1)+1000.,y(1),0.,1)
       call line3d(x(1),y(1),0.,x(1),y(1)+1000.,0.,3)
       call line3d(x(1),y(1),0.,x(1),y(1),z(1),4)

       end do

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      Writes console report
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       write (*,'(2A)') "Flight Zone= ", azone
       write (*,'(2A)') "Date= ", adate
       write (*,'(2A)') "Flight code= ", fcode
       write (*,'(2A)') "Glider= ", aglider
       write (*,'(2A)') "Pilot= ", apilot
       write (*,'(A,F4.1,A)') "PTV= ", ptv, " Kg"
       write (*,'(A,I6)') "N points = ", npunts
       Write (*,'(A,F7.2)') "Height difference= ", xhd
       write (*,'(A,F7.2)') "Developed length= ",  xdl
       write (*,'(A,F7.2)') "Glide ratio (with wind)= ", xgrw
       write (*,'(A,F10,A)') "Track duration= ", xtd , " s"      
       write (*,'(A,F5.2,A)') "H speed (with wind)= ", xdl/xtd, " m/s "
       write (*,'(A,F5.2,A)') "H speed (with wind)= ", 3.6*xdl/xtd,
     + " Km/h "
       write (*,'(A,F5.2,A)') "Sink rate (with wind)= ", xhd/xtd, 
     + " m/s "
       write (*,'(A,F7.2,A)') "Wind speed (aprox.)= ", winds, " km/h"
       write (*,'(A,F7.2,A)') "Wind course (N) (aprox.)= ", windc, 
     + " (0-360 deg)"
       write (*,'(A,F7.2,A)') "Flight course TK-LZ= ", fligc*180./pi, 
     + " deg"

c      Average GR

       sac(1)=0.

       do i=2,npunts
       sac(i)=sac(i-1)+vre(i)*(at(i)-at(i-1))
       end do

       write (*,*) 
       write (*,'(A,F8.2,A)') "H distance with no wind= ", 
     + sac(npunts), " m"
       write (*,'(A,F8.2,A)') "H speed with no wind= ", 
     + 3.6*sac(npunts)/xtd, " km/h"
       write (*,'(A,F8.2)') "Average Glide Ratio of flight= ", 
     + sac(npunts)/xhd
       write (*,*)


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      Final del programa principal
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       call dxfend(20)

       call dxfend(25)
       
       write (*,*)
       write (*,*) 
       write (*,*) "OK, end of the analysis. Look at the .txt report "
       write (*,*) 
      
       close (20)
       close (22)
       close (23)
      

       write (*,*)

       end 

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      SUBROUTINE LINE
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       SUBROUTINE line(p1x,p1y,p2x,p2y,linecolor)
c      line P1-P2

       real x1,x2,y1,y2,z1,z2

       write(20,'(A,/,I1,/,A)') "LINE",8,"default"
       write(20,'(I1,/,A)') 6,"CONTINUOUS"
       write(20,'(I2,/,F12.2,/,I2,/,F12.2)') 10,p1x,20,-p1y
       write(20,'(I2,/,F12.2,/,I2,/,F12.2)') 11,p2x,21,-p2y
       write(20,'(I2,/,I2,/,I2,/,I2,/,I2)') 39,0,62,linecolor,0
       return
       end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc        
c     SUBROUTINE LINE 3D
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       SUBROUTINE line3d(p1x,p1y,p1z,p2x,p2y,p2z,linecolor)
c      line P1-P2
       write(25,'(A,/,I1,/,A)') "LINE",8,"default"
       write(25,'(I1,/,A)') 6,"CONTINUOUS"
       write(25,'(I2,/,F10.2,/,I2,/,F10.2,/,I2,/,F8.2)') 
     + 10,p1x,20,p1y,30,p1z
       write(25,'(I2,/,F10.2,/,I2,/,F10.2,/,I2,/,F8.2)') 
     + 11,p2x,21,p2y,31,p2z
       write(25,'(I2,/,I2,/,I2,/,I2,/,I2)') 39,0,62,linecolor,0
       return
       end
       
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c DXF init
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       
       SUBROUTINE dxfinit(nunit)
       
       write(nunit,'(I1,/,A,/,I1)') 0,"SECTION",2
       write(nunit,'(A)') "HEADER"
       write(nunit,'(I1,/,A)') 9,"$EXTMAX"
       write(nunit,'(I2,/,F12.3,/,I2,/,F12.3)') 10,-900.,20,90.
       write(nunit,'(I1,/,A)') 9,"$EXTMIN"
       write(nunit,'(I2,/,F12.3,/,I2,/,F12.3)') 10,5000.,20,-3000.
       write(nunit,'(I1,/,A,/,I1)') 0,"ENDSEC",0
       write(nunit,'(A,/,I1)') "SECTION",2
       write(nunit,'(A,/,I1)') "ENTITIES",0

       return
       end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c DXF end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE dxfend(nunit)

      write(nunit,'(A,/,I1,/,A)') "ENDSEC",0,"EOF"
      return
      end


      
